package com.ynfy.buss.practice.userpractice.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ynfy.buss.practice.userpractice.entity.UserPractice;
import com.ynfy.buss.practice.userpractice.mapper.UserPracticeMapper;
import com.ynfy.buss.practice.userpractice.service.IUserPracticeService;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description: 用户练习表
 * @Author: jeecg-boot
 * @Date: 2023-11-19
 * @Version: V1.0
 */
@Service
public class UserPracticeServiceImpl extends ServiceImpl<UserPracticeMapper, UserPractice> implements IUserPracticeService {

    /**
     * 获取用户最近的练习
     *
     * @return
     */
    @Override
    public List<UserPractice> getRecentPractice() {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();

        Page<UserPractice> page = new Page<UserPractice>(1, 5);

        LambdaQueryWrapper<UserPractice> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(UserPractice::getUserId, user.getId()).orderByDesc(UserPractice::getCommitTime);
        IPage<UserPractice> pageList = page(page, wrapper);
        return pageList.getRecords();
    }
}
